//+------------------------------------------------------------------+
//|                                            RationalSpeedTest.mq5 |
//|                                 (c) 2011.04.03, Vladimir Gomonov |
//|                                            MetaDriver@rambler.ru |
//+------------------------------------------------------------------+
#property copyright "(c) 2011.04.03, Vladimir Gomonov"
#property link      "MetaDriver@rambler.ru"
#property version   "1.00"
#property script_show_inputs

#include <Math\Rational.mqh>

//--- input parameters
input int      Count=1000000;
//+------------------------------------------------------------------+
//| Script program start function                                    |
//+------------------------------------------------------------------+
void OnStart()
  {
    LongRational lra={2345,3456};
    LongRational lrb={67,93};
    LongRational lrc={93,67};
    ulong t = GetTickCount();
    for(int i=0;i<Count;i++)
      {
       lra.Div(lrb); lra.Div(lrc);
       lra.Mul(lrb); lra.Mul(lrc);
       lra.Add(lrb); lra.Add(lrc);
       lra.Sub(lrb); lra.Sub(lrc);
       lra.Norm();
      }
    Print("Common time LongRational test = ", GetTickCount()-t, " ms; // ",Count," calls");
    IntRational ira={2345,3456};
    IntRational irb={67,93};
    IntRational irc={93,67};
    t = GetTickCount();
    for(int i=0;i<Count;i++)
      {
       ira.Div(irb); ira.Div(irc);
       ira.Mul(irb); ira.Mul(irc);
       ira.Add(irb); ira.Add(irc);
       ira.Sub(irb); ira.Sub(irc);
       ira.Norm();
      }
    Print("Common time IntRational test = ", GetTickCount()-t, " ms; // ",Count," calls");
    double da=2345.0/3456.0;
    double db=67.0/93.0;
    double dc=93.0/67.0;
    t = GetTickCount();
     for(int i=0;i<Count;i++)
      {
       da/=db; da/=dc;
       da*=db; da*=dc;
       da+=db; da+=dc;
       da-=db; da-=dc;
      }
    Print("Common time double test = ", GetTickCount()-t, " ms; // ",Count," calls");
    long la=234567891;
    long lb=67;
    long lc=93;
    t = GetTickCount();
     for(int i=0;i<Count;i++)
      {
       la/=lb; la/=lc;
       la*=lb; la*=lc;
       la+=lb; la+=lc;
       la-=lb; la-=lc;
      }
    Print("Common time long test = ", GetTickCount()-t, " ms; // ",Count," calls");
    int ia=234567891;
    int ib=67;
    int ic=93;
    t = GetTickCount();
     for(int i=0;i<Count;i++)
      {
       ia/=ib; ia/=ic;
       ia*=ib; ia*=ic;
       ia+=ib; ia+=ic;
       ia-=ib; ia-=ic;
      }
    Print("Common time int test = ", GetTickCount()-t, " ms; // ",Count," calls");
   
  }
//+------------------------------------------------------------------+
